installation openmano service persistent. Clear other openmano folders
[osm/RO.git] / scripts / install-openmano.sh
1 #!/bin/bash
2
3 ##
4 # Copyright 2015 Telefónica Investigación y Desarrollo, S.A.U.
5 # This file is part of openmano
6 # All Rights Reserved.
7 #
8 # Licensed under the Apache License, Version 2.0 (the "License"); you may
9 # not use this file except in compliance with the License. You may obtain
10 # a copy of the License at
11 #
12 # http://www.apache.org/licenses/LICENSE-2.0
13 #
14 # Unless required by applicable law or agreed to in writing, software
15 # distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
16 # WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
17 # License for the specific language governing permissions and limitations
18 # under the License.
19 #
20 # For those usages not covered by the Apache License, Version 2.0 please
21 # contact with: nfvlabs@tid.es
22 ##
23
24 #ONLY TESTED in Ubuntu 16.04 partially tested in Ubuntu 14.10 14.04 16.04, CentOS7 and RHEL7
25 #Get needed packages, source code and configure to run openmano
26 #Ask for database user and password if not provided
27
28 function usage(){
29 echo -e "usage: sudo $0 [OPTIONS]"
30 echo -e "Install last stable source code in ./openmano and the needed packages"
31 echo -e "On a Ubuntu 16.04 it configures openmano as a service"
32 echo -e " OPTIONS"
33 echo -e " -u USER: database admin user. 'root' by default. Prompts if needed"
34 echo -e " -p PASS: database admin password to be used or installed. Prompts if needed"
35 echo -e " -q --quiet: install in unattended mode"
36 echo -e " -h --help: show this help"
37 echo -e " --develop: install last version for developers, and do not configure as a service"
38 echo -e " --forcedb: reinstall mano_db DB, deleting previous database if exists and creating a new one"
39 echo -e " --force: makes idenpotent, delete previous installations folders if needed"
40 echo -e " --noclone: assumes that openmano was cloned previously and that this script is run from the local repo"
41 echo -e " --no-install-packages: use this option to skip updating and installing the requires packages. This avoid wasting time if you are sure requires packages are present e.g. because of a previous installation"
42 }
43
44 function install_packages(){
45 [ -x /usr/bin/apt-get ] && apt-get install -y $*
46 [ -x /usr/bin/yum ] && yum install -y $*
47
48 #check properly installed
49 for PACKAGE in $*
50 do
51 PACKAGE_INSTALLED="no"
52 [ -x /usr/bin/apt-get ] && dpkg -l $PACKAGE &>> /dev/null && PACKAGE_INSTALLED="yes"
53 [ -x /usr/bin/yum ] && yum list installed $PACKAGE &>> /dev/null && PACKAGE_INSTALLED="yes"
54 if [ "$PACKAGE_INSTALLED" = "no" ]
55 then
56 echo "failed to install package '$PACKAGE'. Revise network connectivity and try again" >&2
57 exit 1
58 fi
59 done
60 }
61
62 function db_exists() {
63 RESULT=`mysqlshow --defaults-extra-file="$2" | grep -v Wildcard | grep -o $1`
64 if [ "$RESULT" == "$1" ]; then
65 echo " DB $1 exists"
66 return 0
67 fi
68 echo " DB $1 does not exist"
69 return 1
70 }
71
72 GIT_URL=https://osm.etsi.org/gerrit/osm/RO.git
73 DBUSER="root"
74 DBPASSWD=""
75 DBPASSWD_PARAM=""
76 QUIET_MODE=""
77 DEVELOP=""
78 FORCEDB=""
79 FORCE=""
80 NOCLONE=""
81 NO_PACKAGES=""
82 while getopts ":u:p:hiq-:" o; do
83 case "${o}" in
84 u)
85 export DBUSER="$OPTARG"
86 ;;
87 p)
88 export DBPASSWD="$OPTARG"
89 export DBPASSWD_PARAM="-p$OPTARG"
90 ;;
91 q)
92 export QUIET_MODE=yes
93 export DEBIAN_FRONTEND=noninteractive
94 ;;
95 h)
96 usage && exit 0
97 ;;
98 -)
99 [ "${OPTARG}" == "help" ] && usage && exit 0
100 [ "${OPTARG}" == "develop" ] && DEVELOP="y" && continue
101 [ "${OPTARG}" == "forcedb" ] && FORCEDB="y" && continue
102 [ "${OPTARG}" == "force" ] && FORCEDB="y" && FORCE="y" && continue
103 [ "${OPTARG}" == "noclone" ] && NOCLONE="y" && continue
104 [ "${OPTARG}" == "quiet" ] && export QUIET_MODE=yes && export DEBIAN_FRONTEND=noninteractive && continue
105 [ "${OPTARG}" == "no-install-packages" ] && export NO_PACKAGES=yes && continue
106 echo -e "Invalid option: '--$OPTARG'\nTry $0 --help for more information" >&2
107 exit 1
108 ;;
109 \?)
110 echo -e "Invalid option: '-$OPTARG'\nTry $0 --help for more information" >&2
111 exit 1
112 ;;
113 :)
114 echo -e "Option '-$OPTARG' requires an argument\nTry $0 --help for more information" >&2
115 exit 1
116 ;;
117 *)
118 usage >&2
119 exit 1
120 ;;
121 esac
122 done
123
124 #check root privileges and non a root user behind
125 [ "$USER" != "root" ] && echo "Needed root privileges" >&2 && exit 1
126 if [[ -z "$SUDO_USER" ]] || [[ "$SUDO_USER" = "root" ]]
127 then
128 [[ -z $QUIET_MODE ]] && read -e -p "Install in the root user (y/N)?" KK
129 [[ -z $QUIET_MODE ]] && [[ "$KK" != "y" ]] && [[ "$KK" != "yes" ]] && echo "Cancelled" && exit 1
130 export SUDO_USER=root
131 fi
132
133 #Discover Linux distribution
134 #try redhat type
135 [ -f /etc/redhat-release ] && _DISTRO=$(cat /etc/redhat-release 2>/dev/null | cut -d" " -f1)
136 #if not assuming ubuntu type
137 [ -f /etc/redhat-release ] || _DISTRO=$(lsb_release -is 2>/dev/null)
138 if [ "$_DISTRO" == "Ubuntu" ]
139 then
140 _RELEASE=$(lsb_release -rs)
141 if [[ ${_RELEASE%%.*} != 14 ]] && [[ ${_RELEASE%%.*} != 16 ]]
142 then
143 [[ -z $QUIET_MODE ]] && read -e -p "WARNING! Not tested Ubuntu version. Continue assuming a trusty (14.XX)'? (y/N)" KK
144 [[ -z $QUIET_MODE ]] && [[ "$KK" != "y" ]] && [[ "$KK" != "yes" ]] && echo "Cancelled" && exit 1
145 _RELEASE = 14
146 fi
147 elif [ "$_DISTRO" == "CentOS" ]
148 then
149 _RELEASE="7"
150 if ! cat /etc/redhat-release | grep -q "7."
151 then
152 [[ -z $QUIET_MODE ]] && read -e -p "WARNING! Not tested CentOS version. Continue assuming a '_RELEASE' type? (y/N)" KK
153 [[ -z $QUIET_MODE ]] && [[ "$KK" != "y" ]] && [[ "$KK" != "yes" ]] && echo "Cancelled" && exit 1
154 fi
155 elif [ "$_DISTRO" == "Red" ]
156 then
157 _RELEASE="7"
158 if ! cat /etc/redhat-release | grep -q "7."
159 then
160 [[ -z $QUIET_MODE ]] && read -e -p "WARNING! Not tested Red Hat OS version. Continue assuming a '_RELEASE' type? (y/N)" KK
161 [[ -z $QUIET_MODE ]] && [[ "$KK" != "y" ]] && [[ "$KK" != "yes" ]] && echo "Cancelled" && exit 1
162 fi
163 else #[ "$_DISTRO" != "Ubuntu" -a "$_DISTRO" != "CentOS" -a "$_DISTRO" != "Red" ]
164 _DISTRO_DISCOVER=$_DISTRO
165 [ -x /usr/bin/apt-get ] && _DISTRO="Ubuntu" && _RELEASE="14"
166 [ -x /usr/bin/yum ] && _DISTRO="CentOS" && _RELEASE="7"
167 [[ -z $QUIET_MODE ]] && read -e -p "WARNING! Not tested Linux distribution '$_DISTRO_DISCOVER '. Continue assuming a '$_DISTRO $_RELEASE' type? (y/N)" KK
168 [[ -z $QUIET_MODE ]] && [[ "$KK" != "y" ]] && [[ "$KK" != "yes" ]] && echo "Cancelled" && exit 1
169 fi
170
171 #check if installed as a service
172 INSTALL_AS_A_SERVICE=""
173 [[ "$_DISTRO" == "Ubuntu" ]] && [[ ${_RELEASE%%.*} == 16 ]] && [[ -z $DEVELOP ]] && INSTALL_AS_A_SERVICE="y"
174 #Next operations require knowing OPENMANO_BASEFOLDER
175 if [[ -z "$NOCLONE" ]]; then
176 OPENMANO_BASEFOLDER="${PWD}/openmano"
177 [[ -n "$FORCE" ]] && rm -rf $OPENMANO_BASEFOLDER #make idenpotent
178 else
179 HERE=$(realpath $(dirname $0))
180 OPENMANO_BASEFOLDER=$(dirname $HERE)
181 fi
182
183
184 if [[ -z "$NO_PACKAGES" ]]
185 then
186 echo '
187 #################################################################
188 ##### UPDATE REPOSITORIES #####
189 #################################################################'
190 [ "$_DISTRO" == "Ubuntu" ] && apt-get update -y
191
192 [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && yum check-update -y
193 [ "$_DISTRO" == "CentOS" ] && sudo yum install -y epel-release
194 [ "$_DISTRO" == "Red" ] && wget http://dl.fedoraproject.org/pub/epel/7/x86_64/e/epel-release-7-5.noarch.rpm \
195 && sudo rpm -ivh epel-release-7-5.noarch.rpm && sudo yum install -y epel-release && rm -f epel-release-7-5.noarch.rpm
196 [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && sudo yum repolist
197
198 fi
199
200 if [[ -z "$NO_PACKAGES" ]]
201 then
202 echo '
203 #################################################################
204 ##### INSTALL REQUIRED PACKAGES #####
205 #################################################################'
206 [ "$_DISTRO" == "Ubuntu" ] && install_packages "git screen wget mysql-server"
207 [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && install_packages "git screen wget mariadb mariadb-server"
208
209 if [[ "$_DISTRO" == "Ubuntu" ]]
210 then
211 #start services. By default CentOS does not start services
212 service mysql start >> /dev/null
213 # try to set admin password, ignore if fails
214 [[ -n $DBPASSWD ]] && mysqladmin -u $DBUSER -s password $DBPASSWD
215 fi
216
217 if [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ]
218 then
219 #start services. By default CentOS does not start services
220 service mariadb start
221 service httpd start
222 systemctl enable mariadb
223 systemctl enable httpd
224 read -e -p "Do you want to configure mariadb (recommended if not done before) (Y/n)" KK
225 [ "$KK" != "n" -a "$KK" != "no" ] && mysql_secure_installation
226
227 read -e -p "Do you want to set firewall to grant web access port 80,443 (Y/n)" KK
228 [ "$KK" != "n" -a "$KK" != "no" ] &&
229 firewall-cmd --permanent --zone=public --add-service=http &&
230 firewall-cmd --permanent --zone=public --add-service=https &&
231 firewall-cmd --reload
232 fi
233 fi #[[ -z "$NO_PACKAGES" ]]
234
235 #check and ask for database user password. Must be done after database installation
236 if [[ -n $QUIET_MODE ]]
237 then
238 echo -e "\nCheking database connection and ask for credentials"
239 while ! mysqladmin -s -u$DBUSER $DBPASSWD_PARAM status >/dev/null
240 do
241 [ -n "$logintry" ] && echo -e "\nInvalid database credentials!!!. Try again (Ctrl+c to abort)"
242 [ -z "$logintry" ] && echo -e "\nProvide database credentials"
243 read -e -p "database user? ($DBUSER) " DBUSER_
244 [ -n "$DBUSER_" ] && DBUSER=$DBUSER_
245 read -e -s -p "database password? (Enter for not using password) " DBPASSWD_
246 [ -n "$DBPASSWD_" ] && DBPASSWD="$DBPASSWD_" && DBPASSWD_PARAM="-p$DBPASSWD_"
247 [ -z "$DBPASSWD_" ] && DBPASSWD="" && DBPASSWD_PARAM=""
248 logintry="yes"
249 done
250 fi
251
252 if [[ -z "$NO_PACKAGES" ]]
253 then
254 echo '
255 #################################################################
256 ##### INSTALL PYTHON PACKAGES #####
257 #################################################################'
258 [ "$_DISTRO" == "Ubuntu" ] && install_packages "python-yaml python-bottle python-mysqldb python-jsonschema python-paramiko python-argcomplete python-requests python-logutils libxml2-dev libxslt-dev python-dev python-pip"
259 [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && install_packages "PyYAML MySQL-python python-jsonschema python-paramiko python-argcomplete python-requests python-logutils libxslt-devel libxml2-devel python-devel python-pip"
260
261 #required for vmware connector TODO move that to separete opt in install script
262 sudo pip install --upgrade pip
263 sudo pip install pyvcloud
264 sudo pip install progressbar
265 sudo pip install prettytable
266
267 #The only way to install python-bottle on Centos7 is with easy_install or pip
268 [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && easy_install -U bottle
269
270 #install openstack client needed for using openstack as a VIM
271 [ "$_DISTRO" == "Ubuntu" ] && install_packages "python-novaclient python-keystoneclient python-glanceclient python-neutronclient"
272 [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && install_packages "python-devel" && easy_install python-novaclient python-keystoneclient python-glanceclient python-neutronclient #TODO revise if gcc python-pip is needed
273 fi #[[ -z "$NO_PACKAGES" ]]
274
275 if [[ -z $NOCLONE ]]; then
276 echo '
277 #################################################################
278 ##### DOWNLOAD SOURCE #####
279 #################################################################'
280 su $SUDO_USER -c "git clone ${GIT_URL} ${OPENMANO_BASEFOLDER}"
281 su $SUDO_USER -c "cp ${OPENMANO_BASEFOLDER}/.gitignore-common ${OPENMANO_BASEFOLDER}/.gitignore"
282 [[ -z $DEVELOP ]] && su $SUDO_USER -c "git -C ${OPENMANO_BASEFOLDER} checkout tags/v1.0.1"
283 fi
284
285 echo '
286 #################################################################
287 ##### CREATE DATABASE #####
288 #################################################################'
289 echo -e "\nCreating temporary file form MYSQL installation and initialization"
290 TEMPFILE="$(mktemp -q --tmpdir "installopenmano.XXXXXX")"
291 trap 'rm -f "$TEMPFILE"' EXIT
292 chmod 0600 "$TEMPFILE"
293 echo -e "[client]\n user='$DBUSER'\n password='$DBPASSWD'">"$TEMPFILE"
294
295 if db_exists "mano_db" $TEMPFILE ; then
296 if [[ -n $FORCEDB ]]; then
297 echo " Deleting previous database mano_db"
298 DBDELETEPARAM=""
299 [[ -n $QUIET_MODE ]] && DBDELETEPARAM="-f"
300 mysqladmin --defaults-extra-file=$TEMPFILE -s drop mano_db $DBDELETEPARAM || ! echo "Could not delete mano_db database" || exit 1
301 #echo "REVOKE ALL PRIVILEGES ON mano_db.* FROM 'mano'@'localhost';" | mysql --defaults-extra-file=$TEMPFILE -s || ! echo "Failed while creating user mano at database" || exit 1
302 #echo "DELETE USER 'mano'@'localhost';" | mysql --defaults-extra-file=$TEMPFILE -s || ! echo "Failed while creating user mano at database" || exit 1
303 mysqladmin --defaults-extra-file=$TEMPFILE -s create mano_db || ! echo "Error creating mano_db database" || exit 1
304 echo "DROP USER 'mano'@'localhost';" | mysql --defaults-extra-file=$TEMPFILE -s || ! echo "Failed while creating user mano at database" || exit 1
305 echo "CREATE USER 'mano'@'localhost' identified by 'manopw';" | mysql --defaults-extra-file=$TEMPFILE -s || ! echo "Failed while creating user mano at database" || exit 1
306 echo "GRANT ALL PRIVILEGES ON mano_db.* TO 'mano'@'localhost';" | mysql --defaults-extra-file=$TEMPFILE -s || ! echo "Failed while creating user mano at database" || exit 1
307 echo " Database 'mano_db' created, user 'mano' password 'manopw'"
308 else
309 echo "Database exists. Use option '--forcedb' to force the deletion of the existing one" && exit 1
310 fi
311 else
312 mysqladmin -u$DBUSER $DBPASSWD_PARAM -s create mano_db || ! echo "Error creating mano_db database" || exit 1
313 echo "CREATE USER 'mano'@'localhost' identified by 'manopw';" | mysql --defaults-extra-file=$TEMPFILE -s || ! echo "Failed while creating user mano at database" || exit 1
314 echo "GRANT ALL PRIVILEGES ON mano_db.* TO 'mano'@'localhost';" | mysql --defaults-extra-file=$TEMPFILE -s || ! echo "Failed while creating user mano at database" || exit 1
315 echo " Database 'mano_db' created, user 'mano' password 'manopw'"
316 fi
317
318
319 echo '
320 #################################################################
321 ##### INIT DATABASE #####
322 #################################################################'
323 su $SUDO_USER -c "${OPENMANO_BASEFOLDER}/database_utils/init_mano_db.sh -u mano -p manopw -d mano_db" || ! echo "Failed while initializing database" || exit 1
324
325
326 if [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ]
327 then
328 echo '
329 #################################################################
330 ##### CONFIGURE firewalld #####
331 #################################################################'
332 KK=yes
333 [[ -z $QUIET_MODE ]] && read -e -p "Configure firewalld for openmanod port 9090? (Y/n)" KK
334 if [ "$KK" != "n" -a "$KK" != "no" ]
335 then
336 #Creates a service file for openmano
337 echo '<?xml version="1.0" encoding="utf-8"?>
338 <service>
339 <short>openmanod</short>
340 <description>openmanod service</description>
341 <port protocol="tcp" port="9090"/>
342 </service>' > /etc/firewalld/services/openmanod.xml
343 #put proper permissions
344 pushd /etc/firewalld/services > /dev/null
345 restorecon openmanod.xml
346 chmod 640 openmanod.xml
347 popd > /dev/null
348 #Add the openmanod service to the default zone permanently and reload the firewall configuration
349 firewall-cmd --permanent --add-service=openmanod > /dev/null
350 firewall-cmd --reload > /dev/null
351 echo "done."
352 else
353 echo "skipping."
354 fi
355 fi
356
357 echo '
358 #################################################################
359 ##### CONFIGURE OPENMANO CLIENT #####
360 #################################################################'
361 #creates a link at ~/bin if not configured as a service
362 if [[ -z "$INSTALL_AS_A_SERVICE" ]]
363 then
364 su $SUDO_USER -c 'mkdir -p ${HOME}/bin'
365 su $SUDO_USER -c 'rm -f ${HOME}/bin/openmano'
366 su $SUDO_USER -c 'rm -f ${HOME}/bin/openmano-report'
367 su $SUDO_USER -c 'rm -f ${HOME}/bin/service-openmano'
368 su $SUDO_USER -c 'ln -s '${OPENMANO_BASEFOLDER}'/openmano ${HOME}/bin/openmano'
369 su $SUDO_USER -c 'ln -s '${OPENMANO_BASEFOLDER}'/scripts/openmano-report.sh ${HOME}/bin/openmano-report'
370 su $SUDO_USER -c 'ln -s '${OPENMANO_BASEFOLDER}'/scripts/service-openmano.sh ${HOME}/bin/service-openmano'
371
372 #insert /home/<user>/bin in the PATH
373 #skiped because normally this is done authomatically when ~/bin exist
374 #if ! su $SUDO_USER -c 'echo $PATH' | grep -q "${HOME}/bin"
375 #then
376 # echo " inserting /home/$SUDO_USER/bin in the PATH at .bashrc"
377 # su $SUDO_USER -c 'echo "PATH=\$PATH:\${HOME}/bin" >> ~/.bashrc'
378 #fi
379 if [[ $SUDO_USER == root ]]
380 then
381 if ! echo $PATH | grep -q "${HOME}/bin"
382 then
383 echo "PATH=\$PATH:\${HOME}/bin" >> ${HOME}/.bashrc
384 fi
385 fi
386 fi
387
388 #configure arg-autocomplete for this user
389 #in case of minimal instalation this package is not installed by default
390 [[ "$_DISTRO" == "CentOS" || "$_DISTRO" == "Red" ]] && yum install -y bash-completion
391 #su $SUDO_USER -c 'mkdir -p ~/.bash_completion.d'
392 su $SUDO_USER -c 'activate-global-python-argcomplete --user'
393 if ! su $SUDO_USER -c 'grep -q bash_completion.d/python-argcomplete.sh ${HOME}/.bashrc'
394 then
395 echo " inserting .bash_completion.d/python-argcomplete.sh execution at .bashrc"
396 su $SUDO_USER -c 'echo ". ${HOME}/.bash_completion.d/python-argcomplete.sh" >> ~/.bashrc'
397 fi
398
399
400
401
402 if [[ -n "$INSTALL_AS_A_SERVICE" ]]
403 then
404 echo '
405 #################################################################
406 ##### CONFIGURE OPENMANO SERVICE #####
407 #################################################################'
408
409 ${OPENMANO_BASEFOLDER}/scripts/install-openmano-service.sh -f ${OPENMANO_BASEFOLDER} #-u $SUDO_USER
410 # rm -rf ${OPENMANO_BASEFOLDER}
411 # alias service-openmano="service openmano"
412 # echo 'alias service-openmano="service openmano"' >> ${HOME}/.bashrc
413
414 echo
415 echo "Done! installed at /opt/openmano"
416 echo " Manage server with 'sudo service openmano start|stop|status|...' "
417
418
419 else
420
421 echo
422 echo "Done! you may need to logout and login again for loading client configuration"
423 echo " Run './${OPENMANO_BASEFOLDER}/scripts/service-openmano.sh start' for starting openmano in a screen"
424
425 fi
426
427
428